## START: Set by rpmautospec
## (rpmautospec version 0.6.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond docs 1

Name:           libipuz
Version:        0.4.6.3
Release:        %autorelease
Summary:        Library for parsing .ipuz puzzle files

License:        LGPL-2.1-or-later OR MIT
URL:            https://gitlab.gnome.org/jrb/libipuz
Source:         %{url}/-/archive/%{version}/%{name}-%{version}.tar.gz

# Ensure we only enable introspection support from 0.4.7 onwards
%bcond introspection %([ $(echo %{version} | tr -d .) -eq 047 ] && echo 1 || echo 0)

BuildRequires:  cargo-rpm-macros >= 24
BuildRequires:  gcc
BuildRequires:  gettext
BuildRequires:  meson
BuildRequires:  python3
BuildRequires:  sed
%if %{with docs}
BuildRequires:  python3dist(sphinx)
BuildRequires:  python3dist(sphinx-rtd-theme)
BuildRequires:  python3dist(myst-parser)
%endif

BuildRequires:  glib2-devel
BuildRequires:  json-glib-devel
%if %{with introspection}
BuildRequires:  gi-docgen
BuildRequires:  gobject-introspection-devel
%endif

%description
This is a library for parsing .ipuz puzzle files, for crossword puzzles,
sudokus, etc. The library only handles crosswords for now.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
%if %{with docs}
Suggests:       %{name}-doc = %{version}-%{release}
%endif

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%if %{with docs}
%package        doc
Summary:        Documentation for %{name}
BuildArch:      noarch

%description    doc
This package contains additional documentation for %{name}.
%endif

%package        tests
Summary:        Tests for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    tests
The %{name}-tests package contains tests for %{name}.

%prep
%autosetup -p1
%cargo_prep

# Drop version locks
rm libipuz/rust/Cargo.lock
sed -i '/Cargo.lock/d' libipuz/rust/meson.build

%generate_buildrequires
cd libipuz/rust
%cargo_generate_buildrequires

%build
%meson
%meson_build

%if %{with docs}
sphinx-build-3 docs html
rm -rf html/.{doctrees,buildinfo}
%endif

%install
%meson_install

%check
%meson_test

%files
%license LICENSE COPYING.LGPL COPYING.MIT
%doc README.md NEWS.md
%{_libdir}/lib%{name}-0.4.so

%files devel
%{_includedir}/*
%if %{with introspection}
%{_datadir}/gir-1.0/Ipuz-1.0.gir
%{_libdir}/girepository-1.0/Ipuz-1.0.typelib
%endif
%{_libdir}/pkgconfig/%{name}-0.4.pc

%if %{with docs}
%files doc
%license LICENSE COPYING.LGPL COPYING.MIT
%doc html
%if %{with introspection}
%doc %{_docdir}/%{name}-1.0/
%endif
%endif

%files tests
%dir %{_datadir}/installed-tests
%{_datadir}/installed-tests/%{name}-1.0
%dir %{_libexecdir}/installed-tests
%{_libexecdir}/installed-tests/%{name}-1.0

%changelog
## START: Generated by rpmautospec
* Sat May 25 2024 Davide Cavalca <dcavalca@fedoraproject.org> - 0.4.6.3-1
- Update to 0.4.6.3; Fixes: RHBZ#2282224

* Fri May 24 2024 Fabio Valentini <decathorpe@gmail.com> - 0.4.6.2-2
- Rebuild with Rust 1.78 to fix incomplete debuginfo and backtraces

* Mon May 20 2024 Davide Cavalca <dcavalca@fedoraproject.org> - 0.4.6.2-1
- Update to 0.4.6.2; Fixes: RHBZ#2281417

* Wed Mar 20 2024 Davide Cavalca <dcavalca@fedoraproject.org> - 0.4.5-4
- Add rust support in preparation for 0.4.6

* Thu Jan 25 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sun Jan 21 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.5-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Jan 15 2024 Davide Cavalca <dcavalca@fedoraproject.org> - 0.4.5-1
- Update to 0.4.5; Fixes: RHBZ#2256045

* Mon Sep 04 2023 Davide Cavalca <dcavalca@fedoraproject.org> - 0.4.4-1
- Update to 0.4.4; Fixes: RHBZ#2235396. RHBZ#2233124

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Sun Apr 02 2023 Davide Cavalca <dcavalca@fedoraproject.org> - 0.4.2-1
- Update to 0.4.2; Fixes: RHBZ#2182964

* Sun Jan 22 2023 Davide Cavalca <dcavalca@fedoraproject.org> - 0.4.1-2
- Build documentation

* Sun Jan 22 2023 Davide Cavalca <dcavalca@fedoraproject.org> - 0.4.1-1
- Update to 0.4.1; Fixes: RHBZ#2161823

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Sun Nov 06 2022 Davide Cavalca <dcavalca@fedoraproject.org> - 0.3.0-1
- Update to 0.3.0; Fixes: RHBZ#2140442

* Thu Oct 27 2022 Davide Cavalca <dcavalca@fedoraproject.org> - 0.2.0-1
- Initial import; Fixes: RHBZ#2137748
## END: Generated by rpmautospec
